<?php

class InventoryItem extends Item
{
    private $present;

    public function __construct($row)
    {
        parent::__construct($row);
        $this->present = $row['present'];

        if ($this->artefact) $this->name = <<<NAME
<b style='color: crimson;'>{$this->name}</b> <img src="//{$_SERVER['SERVER_NAME']}/i/artefact1.gif">
NAME;
    }

    public function printInfo()
    {
        parent::printBaseInfo();
        parent::printRequirements();
        parent::printBonuses();
        if ($this->present) echo "<p style='color: maroon; font-style: italic'>Это подарок от {$this->present}. Вы не можете передать его кому-либо ещё.</p>";
    }

    public function printImage()
    {
        if (!in_array($this->type,[12,50,200])) {
            echo "<a href=//{$_SERVER['SERVER_NAME']}/main.php?edit=1&dress={$this->id} title='Надеть'>";
            parent::printImage();
            echo "</a>";
        }
        else parent::printImage();
    }

    /**
     * Для кнопок управления под картинкой предмета в зависимости от ситуации.
     */
    public function printControls()
    {
        echo <<<BTN
<p><input type="button" style="background: brown; border: 1px solid grey; color: white; border-radius: 2px;" value="Выбросить"
                                   onclick="location='/admin.php'">
BTN;
    }

    public function getId()
    {
        return $this->id;
    }
}